# NAME

tblgen - Target Description To C++ Code Generator

# SYNOPSIS

tblgen [options] [filename]

# DESCRIPTION

tblgen translates from target description (.td) files into C++ code that can be included in the definition of an LLVM target library. Most users of LLVM will not need to use this program. It is only for assisting with writing an LLVM target backend.

The input and output of tblgen is beyond the scope of this short introduction. Please see the CodeGeneration page in the LLVM documentation.

The filename argument specifies the name of a Target Description (.td) file to read as input.

# OPTIONS

-help

  Print a summary of command line options.

-o filename

  Specify the output file name. If filename is `-`, then tblgen sends its output to standard output.

-I directory

  Specify where to find other target description files for inclusion. The directory value should be a full or partial path to a directory that contains target description files.

-asmwriternum N

  Make -gen-asm-writer emit assembly writer number N.

-class class Name

  Print the enumeration list for this class.

-print-records

  Print all records to standard output (default).

-print-enums

  Print enumeration values for a class

-gen-emitter

  Generate machine code emitter.

-gen-register-enums

  Generate the enumeration values for all registers.

-gen-register-desc

  Generate a register info description for each register.

-gen-register-desc-header

  Generate a register info description header for each register.

-gen-instr-enums

  Generate enumeration values for instructions.

-gen-instr-desc

  Generate instruction descriptions.

-gen-asm-writer

  Generate the assembly writer.

-gen-dag-isel

  Generate a DAG (Directed Acycle Graph) instruction selector.

-gen-subtarget

  Generate subtarget enumerations.

-gen-intrinsic

  Generate intrinsic information.

-version

  Show the version number of this program.

# EXIT STATUS

If tblgen succeeds, it will exit with 0. Otherwise, if an error occurs, it will exit with a non-zero value.

# AUTHORS

Maintained by The LLVM Team (http://llvm.org/).